SystemOrganization addCategory: #'EjerciciosPoo-OnlineSale'!

Error subclass: #CanNotAddANegativeOrZeroQuantityException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

Object subclass: #Cart
	instanceVariableNames: 'productsContained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 09:29'!
add: aNewProduct quantity: aQuantityOfProduct 
	(aQuantityOfProduct > 0) 
		ifTrue:[productsContained add: aNewProduct withOccurrences: aQuantityOfProduct.] 
		ifFalse: [CanNotAddANegativeOrZeroQuantityException signal.]
! !

!Cart methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:51'!
contains: aProduct 
	^ productsContained includes: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:27'!
initialize
	productsContained:= Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:12'!
quantityOf: aProduct
	^productsContained occurrencesOf: aProduct.
	! !

!Cart methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:26'!
quantityOfProducts
	^ productsContained size.! !

Object subclass: #Product
	instanceVariableNames: 'isbn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!Product class methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:24'!
newWith: anIsbn
	^self new initializeWith: anIsbn.! !

!Product methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:22'!
= aProduct.
	(aProduct isKindOf: self class)
		ifTrue: [^aProduct isbn = self isbn.] 
		ifFalse: [^false.]! !

!Product methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 09:20'!
hash
 	^self isbn.! !

!Product methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:21'!
initializeWith: anIsbn
	isbn := anIsbn.! !

!Product methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:22'!
isbn
	^isbn.! !

TestCase subclass: #OnlineSaleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-OnlineSale'!

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 20:57'!
aCart
	^Cart new.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 09:24'!
aProduct
	^ Product newWith: 1.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 09:24'!
aSecondProduct
	^ Product newWith: 2.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 09:24'!
aThirdProduct
	^ Product newWith: 3.! !

!OnlineSaleTest methodsFor: 'accessing' stamp: 'GabrielBursztyn 6/12/2012 16:42'!
shouldNotAddANegativeOrZeroQuantityException
	^CanNotAddANegativeOrZeroQuantityException.! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 20:29'!
test01NewCartCannotContainsProducts

	self assert: (self aCart) quantityOfProducts = 0.
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 21:01'!
test02GivenACartWhenAddAProductThenTheCartContainThis

	| aCart aProduct|
	
	aCart := self aCart.
	aProduct := self aProduct.
	aCart add: aProduct quantity: 3.
	
	self assert: (aCart contains: aProduct).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/7/2012 21:08'!
test03GivenACartWhenAddAProductThenTheCartNotContainAnotherProduct

	| aCart aProduct aSecondProduct|
	
	aCart := self aCart.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCart add: aProduct quantity: 3.
	
	self deny: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:29'!
test04GivenACartWhenAddAProductThenTheCartContainsTheQuantityAddedOfThatProduct

	| aCart aProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	aCart add: aProduct quantity: 3.
	self assert: (aCart quantityOfProducts = 3).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:28'!
test05GivenACartWhenAddAProductThatAlreadyExistsThenTheCartContainsTheSumOfTheQuantities

	| aCart aProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 4.
	self assert: (aCart quantityOfProducts = 7).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:42'!
test06GivenACartWhenAddAProductThenTheQuantityShouldNotBeNegative

	| aCart aProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	self should: [ aCart add: aProduct quantity: -1] raise: self shouldNotAddANegativeOrZeroQuantityException.
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:42'!
test07GivenACartWhenAddAProductThenTheQuantityShouldNotBeZero

	| aCart aProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	self should: [ aCart add: aProduct quantity: 0] raise: self shouldNotAddANegativeOrZeroQuantityException.
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 00:07'!
test08GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsBothProducts

	| aCart aProduct aSecondProduct|
	
	aCart := self aCart.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'GabrielBursztyn 6/12/2012 16:52'!
test09GivenACartWhenAddAProductAndAnotherProductThenTheCartCanReturnAListOfTheProductsWithItsQuantities

	| aCart aProduct aSecondProduct|
	
	aCart := self aCart.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aSecondProduct quantity: 1.

	self assert: (aCart contains: aProduct).	
	self assert: (aCart contains: aSecondProduct).
	! !

!OnlineSaleTest methodsFor: 'as yet unclassified' stamp: 'Satelier 6/13/2012 09:26'!
test10GivenACartWhenAddAProductAndAnotherProductThenTheCartContainsTheCorrectedQuantityOfThem

	| aCart aProduct aSecondProduct aThirdProduct |
	
	aCart := self aCart.
	aProduct := self aProduct.
	aSecondProduct := self aSecondProduct.
	aThirdProduct := self aThirdProduct.
	aCart add: aProduct quantity: 3.
	aCart add: aProduct quantity: 2.
	aCart add: aSecondProduct quantity: 1.

	self assert: ((aCart quantityOf: aProduct) = 5).	
	self assert: ((aCart quantityOf: aSecondProduct) = 1).
	self assert: ((aCart quantityOf: aThirdProduct) = 0).! !
